/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.device.wrapper;

import org.springblade.community.entity.Building;
import org.springblade.community.entity.Floor;
import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IBuildingClient;
import org.springblade.community.feign.IFloorClient;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.device.entity.GbDeviceChannel;
import org.springblade.device.vo.GbDeviceChannelVO;
import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-12-06
 */
public class GbDeviceChannelWrapper extends BaseEntityWrapper<GbDeviceChannel, GbDeviceChannelVO>  {

	private static IResidentialClient residentialClient;
	private static IBuildingClient buildingClient;
	private static IFloorClient floorClient;

	public static GbDeviceChannelWrapper build() {
		return new GbDeviceChannelWrapper();
 	}

 	static {
		residentialClient = SpringUtil.getBean(IResidentialClient.class);
		buildingClient = SpringUtil.getBean(IBuildingClient.class);
		floorClient = SpringUtil.getBean(IFloorClient.class);
	}

	@Override
	public GbDeviceChannelVO entityVO(GbDeviceChannel gbDeviceChannel) {
		GbDeviceChannelVO gbDeviceChannelVO = Objects.requireNonNull(BeanUtil.copy(gbDeviceChannel, GbDeviceChannelVO.class));
		StringBuilder sb = new StringBuilder();
		if(gbDeviceChannelVO.getResidentialId() != null){
			Residential residential = residentialClient.getById(gbDeviceChannelVO.getResidentialId());
			sb.append(residential.getName());
			if(gbDeviceChannelVO.getBuildingId() != null){
				Building building = buildingClient.getById(gbDeviceChannelVO.getBuildingId());
				sb.append("|").append(building.getName());
			}
			if(gbDeviceChannelVO.getFloorId() != null){
				Floor floor = floorClient.getById(gbDeviceChannelVO.getFloorId());
				sb.append("|").append(floor.getName());
			}
		}
		if(StringUtil.isNotBlank(gbDeviceChannelVO.getInstallAddress())){
			sb.append("|").append(gbDeviceChannelVO.getInstallAddress());
		}
		gbDeviceChannelVO.setInstallLocal(sb.toString());
		return gbDeviceChannelVO;
	}

}
